# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`bolt_pe`](#bolt_pe): Class: bolt_pe

### Tasks

* [`get_targets_from_node_groups`](#get_targets_from_node_groups): This task reads node groups from PE console and returns an array of nodes being part of the node group
* [`terrafom_apply`](#terrafom_apply): Apply an HCL manifest
* [`terrafom_destroy`](#terrafom_destroy): Destroy resources managed with Terraform
* [`terrafom_initialize`](#terrafom_initialize): Initialize a Terraform project directory
* [`terrafom_output`](#terrafom_output): JSON representation of Terraform outputs
* [`terrafom_resolve_reference`](#terrafom_resolve_reference): Generate targets from Terraform Statefile

### Plans

* [`bolt_pe::get_node_groups`](#bolt_peget_node_groups): get all node groups and print to stdout
* [`bolt_pe::terraform_apply`](#bolt_peterraform_apply)
* [`bolt_pe::terraform_destroy`](#bolt_peterraform_destroy)

## Classes

### <a name="bolt_pe"></a>`bolt_pe`

Class: bolt_pe

## Tasks

### <a name="get_targets_from_node_groups"></a>`get_targets_from_node_groups`

This task reads node groups from PE console and returns an array of nodes being part of the node group

**Supports noop?** false

#### Parameters

##### `node_group`

Data type: `String`

Name of the node group

### <a name="terrafom_apply"></a>`terrafom_apply`

Apply an HCL manifest

**Supports noop?** false

#### Parameters

##### `dir`

Data type: `Optional[String[1]]`

Path to Terraform project directory. Path is relative to CWD, unless an absolute path is specified.

##### `state`

Data type: `Optional[String[1]]`

Path to read and save state. Defaults to "terraform.tfstate". Path is relative to "dir"

##### `target`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Resource to target. Operation will be limited to this resource and its dependencies. Accepts a single resource string or an array of resources

##### `var`

Data type: `Optional[Hash]`

Set Terraform variables, expects a hash with key value pairs representing variables and values.

##### `var_file`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Set variables in the Terraform configuration from a file. Path is relative to "dir". Accepts a single var-file path or an array of paths

##### `state_out`

Data type: `Optional[String[1]]`

Path to write state to that is different than "state". This can be used to preserve the old state.

### <a name="terrafom_destroy"></a>`terrafom_destroy`

Destroy resources managed with Terraform

**Supports noop?** false

#### Parameters

##### `dir`

Data type: `Optional[String[1]]`

Path to Terraform project directory. Path is relative to CWD, unless an absolute path is specified.

##### `state`

Data type: `Optional[String[1]]`

Path to read and save state. Defaults to "terraform.tfstate", Path is relative to "dir"

##### `target`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Resource to target. Operation will be limited to this resource and its dependencies. Accepts a single resource string or an array of resources

##### `var`

Data type: `Optional[Hash]`

Set Terraform variables, expects a hash with key value pairs representing variables and values.

##### `var_file`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Set variables in the Terraform configuration from a file. Path is relative to "dir". Accepts a single var-file path or an array of paths

##### `state_out`

Data type: `Optional[String[1]]`

Path to write state to that is different than "state". This can be used to preserve the old state.

### <a name="terrafom_initialize"></a>`terrafom_initialize`

Initialize a Terraform project directory

**Supports noop?** false

#### Parameters

##### `dir`

Data type: `Optional[String[1]]`

Path to Terraform project directory. Path is relative to CWD, unless an absolute path is specified.

### <a name="terrafom_output"></a>`terrafom_output`

JSON representation of Terraform outputs

**Supports noop?** false

#### Parameters

##### `dir`

Data type: `Optional[String[1]]`

Path to Terraform project directory. Path is relative to CWD, unless an absolute path is specified.

##### `state`

Data type: `Optional[String[1]]`

Path to read and save state. Defaults to "terraform.tfstate", Path is relative to "dir"

### <a name="terrafom_resolve_reference"></a>`terrafom_resolve_reference`

Generate targets from Terraform Statefile

**Supports noop?** false

#### Parameters

##### `dir`

Data type: `String[1]`



##### `resource_type`

Data type: `String[1]`



##### `state`

Data type: `Optional[String[1]]`



##### `backend`

Data type: `Optional[String[1]]`



##### `target_mapping`

Data type: `Hash`



## Plans

### <a name="bolt_peget_node_groups"></a>`bolt_pe::get_node_groups`

get all node groups and print to stdout

#### Parameters

The following parameters are available in the `bolt_pe::get_node_groups` plan:

* [`node_group`](#node_group)
* [`puppet_server`](#puppet_server)

##### <a name="node_group"></a>`node_group`

Data type: `Enum['All Nodes', 'Production Environment']`



##### <a name="puppet_server"></a>`puppet_server`

Data type: `String`



### <a name="bolt_peterraform_apply"></a>`bolt_pe::terraform_apply`

The bolt_pe::terraform_apply class.

#### Parameters

The following parameters are available in the `bolt_pe::terraform_apply` plan:

* [`dir`](#dir)
* [`state`](#state)
* [`state_out`](#state_out)
* [`target`](#target)
* [`var`](#var)
* [`var_file`](#var_file)
* [`return_output`](#return_output)
* [`terraform_host`](#terraform_host)

##### <a name="dir"></a>`dir`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="state"></a>`state`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="state_out"></a>`state_out`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="target"></a>`target`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: ``undef``

##### <a name="var"></a>`var`

Data type: `Optional[Hash]`



Default value: ``undef``

##### <a name="var_file"></a>`var_file`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: ``undef``

##### <a name="return_output"></a>`return_output`

Data type: `Optional[Boolean]`



Default value: ``false``

##### <a name="terraform_host"></a>`terraform_host`

Data type: `TargetSpec`



### <a name="bolt_peterraform_destroy"></a>`bolt_pe::terraform_destroy`

The bolt_pe::terraform_destroy class.

#### Parameters

The following parameters are available in the `bolt_pe::terraform_destroy` plan:

* [`dir`](#dir)
* [`state`](#state)
* [`state_out`](#state_out)
* [`target`](#target)
* [`var`](#var)
* [`var_file`](#var_file)
* [`terraform_host`](#terraform_host)

##### <a name="dir"></a>`dir`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="state"></a>`state`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="state_out"></a>`state_out`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="target"></a>`target`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: ``undef``

##### <a name="var"></a>`var`

Data type: `Optional[Hash]`



Default value: ``undef``

##### <a name="var_file"></a>`var_file`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: ``undef``

##### <a name="terraform_host"></a>`terraform_host`

Data type: `TargetSpec`



